/* $Id: ddl_limit.c,v 1.1 1995/02/27 16:04:57 tim Exp $ */

#include <stdio.h>
#include <mpi.h>
#include <stdlib.h>
#include <malloc.h>


#include "ddl.h"

/* Define if you have the setrlimit function.  */
#define HAVE_SETRLIMIT 1

#ifdef HAVE_SETRLIMIT
#include <stdlib.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <signal.h>
#endif

/* Sets maximum CPU time for this process to sec seconds */
void
DDL_Set_cpu_limit(sec)
  int sec;
{
#ifdef HAVE_SETRLIMIT
  struct rlimit limits;
  getrlimit(RLIMIT_CPU, &limits);
  if (sec > limits.rlim_max)
    limits.rlim_cur = limits.rlim_max;
  else {
    limits.rlim_cur = sec;
    limits.rlim_max = sec;
  }
  if (setrlimit(RLIMIT_CPU, &limits)) {
    perror("set_cpu_limit");
    exit(1);
  }
  getrlimit(RLIMIT_CPU, &limits);
  signal(SIGXCPU, SIG_DFL);
#else
  fprintf(stderr, "Warning: setrlimit not supported; CPU limit not changed\n");
#endif
}
