c vector fill routine
c used by sparse library routines

      subroutine dfill (n,v,val)
c***begin prologue  dfill
c***date written   890404   (yymmdd)
c***revision date  890404   (yymmdd)
c***category no.  d2a4,
c***keywords  library=slatec(slap),
c             type=double precision(dfill-d),
c             linear system, sparse, iterative precondition
c***author  seager, mark k., (llnl)
c             lawrence livermore national laboratory
c             po box 808, l-300
c             livermore, ca 94550 (415) 423-3141
c             seager@lll-crg.llnl.gov
c***purpose  fill a vector with a value.
c***description
c *usage:
c     integer  n
c     double precision v(n), val
c
c     call dfill( n, v, val )
c
c *arguments:
c n      :in       integer.
c         length of the vector
c v      :out      double precision v(n).
c         vectored to be set.
c val    :in       double precision.
c         value to seed the vector with.
c***references  (none)
c***routines called  (none)
c***end prologue  dfill
c      implicit double precision(a-h,o-z)
      integer n,nr,is,i
      double precision v(*), val
c
c***first executable statement  dfill
      if (n .le. 0) return
      nr=mod(n,4)
c
c         the following construct assumes a zero pass do loop.
c
      is=1
      goto(1,2,3,4), nr+1
    4   is=4
        v(1)=val
        v(2)=val
        v(3)=val
        goto 1
    3   is=3
        v(1)=val
        v(2)=val
        goto 1
    2   is=2
        v(1)=val
    1 do 10 i=is,n,4
        v(i)  =val
        v(i+1)=val
        v(i+2)=val
        v(i+3)=val
 10   continue
      return
c------------- last line of dfill follows -----------------------------
      end


