c     -*-Fortran-*-
c     $Id: ddlf.h,v 1.3 1995/08/24 10:03:21 tim Exp $

c     umbrella header file for FORTRAN DDL

c     Copyright 1994 IASC

c     type declarations
c     must keep these declarations in step with C code

c     dense types
      integer ddl_vector
      parameter (ddl_vector = 200)
      integer ddl_vec_blk, ddl_vec_rep,ddl_vec_fmt
      parameter (ddl_vec_blk = ddl_vector+1)
      parameter (ddl_vec_rep = ddl_vector+2)
      parameter (ddl_vec_fmt = ddl_vector+3)

c     sparse types
      integer ddl_sparse
      parameter (ddl_sparse = 300)
      integer ddl_row_fmt, ddl_col_fmt, ddl_triad_fmt
      integer ddl_pck_row, ddl_pck_col, ddl_pad_row, ddl_pad_col
      integer ddl_triad_row, ddl_triad_col, ddl_triad
      parameter (ddl_row_fmt = ddl_sparse+1)
      parameter (ddl_col_fmt = ddl_sparse+2)
      parameter (ddl_triad_fmt = ddl_sparse+3)
      parameter (ddl_pck_row = ddl_sparse+4)
      parameter (ddl_pck_col = ddl_sparse+5)
      parameter (ddl_pad_row = ddl_sparse+6)
      parameter (ddl_pad_col = ddl_sparse+7)
      parameter (ddl_triad_row = ddl_sparse+8)
      parameter (ddl_triad_col = ddl_sparse+9)
      parameter (ddl_triad = ddl_sparse+10)

c     DDL error numbers
      integer ddl_err_base
      parameter (ddl_err_base = 100)
      integer ddl_success, ddl_err
      integer ddl_err_unallocated, ddl_err_memory
      integer ddl_err_size, ddl_err_type, ddl_err_format
      integer ddl_err_block, ddl_err_commtop, ddl_err_commdim
      integer ddl_err_used, ddl_err_file, ddl_err_notimplemented
      integer ddl_err_toosmall, ddl_err_fileformat
      integer ddl_err_isize, ddl_err_itype, ddl_err_iformat
      integer ddl_err_icomm, ddl_err_ddltype
      integer ddl_err_toobig, ddl_err_iobj, ddl_err_over
      integer ddl_err_dist, ddl_err_iproptag, ddl_err_notexist
      integer ddl_err_nocommtag
      parameter (ddl_success = 0)
      parameter (ddl_err = ddl_err_base+1)
      parameter (ddl_err_unallocated = ddl_err_base+2)
      parameter (ddl_err_memory = ddl_err_base+3)
      parameter (ddl_err_size = ddl_err_base+4)
      parameter (ddl_err_type = ddl_err_base+5)
      parameter (ddl_err_format = ddl_err_base+6)
      parameter (ddl_err_block = ddl_err_base+7)
      parameter (ddl_err_commtop = ddl_err_base+8)
      parameter (ddl_err_commdim = ddl_err_base+9)
      parameter (ddl_err_used = ddl_err_base+10)
      parameter (ddl_err_file = ddl_err_base+11)
      parameter (ddl_err_notimplemented = ddl_err_base+12)
      parameter (ddl_err_toosmall = ddl_err_base+13)
      parameter (ddl_err_fileformat = ddl_err_base+15)
      parameter (ddl_err_isize = ddl_err_base+16)
      parameter (ddl_err_itype = ddl_err_base+17)
      parameter (ddl_err_iformat = ddl_err_base+18)
      parameter (ddl_err_icomm = ddl_err_base+19)
      parameter (ddl_err_ddltype = ddl_err_base+20)
      parameter (ddl_err_toobig = ddl_err_base+21)
      parameter (ddl_err_iobj = ddl_err_base+22)
      parameter (ddl_err_over = ddl_err_base+23)
      parameter (ddl_err_dist = ddl_err_base+24)
      parameter (ddl_err_iproptag = ddl_err_base+25)
      parameter (ddl_err_notexist = ddl_err_base+26)
      parameter (ddl_err_nocommtag = ddl_err_base+27)

c     error handler procedure numbers
c     generic procedures
      integer ddl_base_generic
      parameter (ddl_base_generic = 100)
      integer ddl_perr_free, ddl_perr_read, ddl_perr_write
      integer ddl_perr_size, ddl_perr_offset
      integer ddl_perr_type, ddl_perr_format, ddl_perr_comm
      integer ddl_perr_error
      integer ddl_perr_init, ddl_perr_finalize, ddl_perr_copy
      integer ddl_perr_fill
      integer ddl_perr_gsize, ddl_perr_skip_host, ddl_perr_block
      integer ddl_perr_objecttype, ddl_perr_tag
      parameter (ddl_perr_free         = ddl_base_generic+  1)
      parameter (ddl_perr_read         = ddl_base_generic+  2)
      parameter (ddl_perr_write        = ddl_base_generic+  3)
      parameter (ddl_perr_size         = ddl_base_generic+  4)
      parameter (ddl_perr_offset       = ddl_base_generic+  5)
      parameter (ddl_perr_type         = ddl_base_generic+  6)
      parameter (ddl_perr_format       = ddl_base_generic+  7)
      parameter (ddl_perr_comm         = ddl_base_generic+  8)
      parameter (ddl_perr_error        = ddl_base_generic+  9)
      parameter (ddl_perr_init         = ddl_base_generic+ 10)
      parameter (ddl_perr_finalize     = ddl_base_generic+ 11)
      parameter (ddl_perr_copy         = ddl_base_generic+ 12)
      parameter (ddl_perr_fill         = ddl_base_generic+ 13)
      parameter (ddl_perr_gsize        = ddl_base_generic+ 14)
      parameter (ddl_perr_skip_host    = ddl_base_generic+ 15)
      parameter (ddl_perr_block        = ddl_base_generic+ 16)
      parameter (ddl_perr_objecttype   = ddl_base_generic+ 17)
      parameter (ddl_perr_tag          = ddl_base_generic+ 18)

c     dense procedures
      integer ddl_base_dense
      parameter (ddl_base_dense = 200)
      integer ddl_perr_create_vector, ddl_perr_free_vector
      integer ddl_perr_write_vector
      integer ddl_perr_read_vector, ddl_perr_size_vector
      integer ddl_perr_type_vector
      integer ddl_perr_format_vector, ddl_perr_offset_vector
      integer ddl_perr_in_vector
      integer ddl_perr_out_vector, ddl_perr_fileformat, ddl_perr_dot
      integer ddl_perr_get_vector, ddl_perr_fileformat_host
      integer ddl_perr_comm_vector
      integer ddl_perr_gsize_vector, ddl_perr_copy_vector
      integer ddl_perr_axpy
      integer ddl_perr_fill_vector, ddl_perr_gather_vector
      integer ddl_perr_scatter_vector
      integer ddl_perr_block_vector
      parameter (ddl_perr_create_vector         = ddl_base_dense+  1)
      parameter (ddl_perr_free_vector           = ddl_base_dense+  2)
      parameter (ddl_perr_write_vector          = ddl_base_dense+  3)
      parameter (ddl_perr_read_vector           = ddl_base_dense+  4)
      parameter (ddl_perr_size_vector           = ddl_base_dense+  5)
      parameter (ddl_perr_type_vector           = ddl_base_dense+  6)
      parameter (ddl_perr_format_vector         = ddl_base_dense+  7)
      parameter (ddl_perr_offset_vector         = ddl_base_dense+  8)
      parameter (ddl_perr_in_vector             = ddl_base_dense+  9)
      parameter (ddl_perr_out_vector            = ddl_base_dense+ 10)
      parameter (ddl_perr_fileformat            = ddl_base_dense+ 11)
      parameter (ddl_perr_dot                   = ddl_base_dense+ 12)
      parameter (ddl_perr_get_vector            = ddl_base_dense+ 13)
      parameter (ddl_perr_fileformat_host       = ddl_base_dense+ 14)
      parameter (ddl_perr_comm_vector           = ddl_base_dense+ 15)
      parameter (ddl_perr_gsize_vector          = ddl_base_dense+ 16)
      parameter (ddl_perr_copy_vector           = ddl_base_dense+ 17)
      parameter (ddl_perr_axpy                  = ddl_base_dense+ 18)
      parameter (ddl_perr_fill_vector           = ddl_base_dense+ 19)
      parameter (ddl_perr_gather_vector         = ddl_base_dense+ 20)
      parameter (ddl_perr_scatter_vector        = ddl_base_dense+ 21)
      parameter (ddl_perr_block_vector          = ddl_base_dense+ 22)

c     support procedures
      integer ddl_base_support
      parameter (ddl_base_support = 400)
      integer ddl_perr_open_host, ddl_perr_close_host
      integer ddl_perr_skip_host_sparse
      integer ddl_perr_skip_host_vector
      parameter (ddl_perr_open_host             = ddl_base_support+  1)
      parameter (ddl_perr_close_host            = ddl_base_support+  2)
      parameter (ddl_perr_skip_host_sparse      = ddl_base_support+  3)
      parameter (ddl_perr_skip_host_vector      = ddl_base_support+  4)

c     sparse procedures
      integer ddl_base_sparse
      parameter (ddl_base_sparse = 300)
      integer ddl_perr_create_sparse, ddl_perr_free_global
      integer ddl_perr_free_sparse
      integer ddl_perr_type_sparse, ddl_perr_size_sparse
      integer ddl_perr_format_sparse
      integer ddl_perr_init_sparse, ddl_perr_finalize_sparse
      integer ddl_perr_info_sparse
      integer ddl_perr_inhb, ddl_perr_in_sparse, ddl_perr_out_sparse
      integer ddl_perr_coltotriad
      integer ddl_perr_offset_sparse, ddl_perr_comm_sparse
      integer ddl_perr_gsize_sparse
      integer ddl_perr_read_sparse, ddl_perr_used_sparse
      integer ddl_perr_setused_sparse
      integer ddl_perr_setformat_sparse, ddl_perr_write_sparse
      integer ddl_perr_gused_sparse
      integer ddl_perr_get_ia, ddl_perr_get_ja, ddl_perr_get_a
      integer ddl_perr_smv_comm
      integer ddl_perr_smv, ddl_perr_copy_sparse, ddl_perr_trisolve
      integer ddl_perr_setsubtype_sparse, ddl_perr_subtype_sparse
      integer ddl_perr_check_perm, ddl_perr_compare_vecvec
      integer ddl_perr_compare_matvec
      integer ddl_perr_block_sparse, ddl_perr_create_prop
      integer ddl_perr_free_prop
      integer ddl_perr_find_prop, ddl_perr_free_allprop
      integer ddl_perr_setperm_sparse
      integer ddl_perr_trisolve_comm, ddl_perr_addperm_vector
      integer ddl_perr_permute_vector, ddl_perr_invperm
      parameter (ddl_perr_create_sparse         = ddl_base_sparse+  1)
      parameter (ddl_perr_free_global           = ddl_base_sparse+  2)
      parameter (ddl_perr_free_sparse           = ddl_base_sparse+  3)
      parameter (ddl_perr_type_sparse           = ddl_base_sparse+  4)
      parameter (ddl_perr_size_sparse           = ddl_base_sparse+  5)
      parameter (ddl_perr_format_sparse         = ddl_base_sparse+  6)
      parameter (ddl_perr_init_sparse           = ddl_base_sparse+  7)
      parameter (ddl_perr_finalize_sparse       = ddl_base_sparse+  9)
      parameter (ddl_perr_info_sparse           = ddl_base_sparse+ 11)
      parameter (ddl_perr_inhb                  = ddl_base_sparse+ 13)
      parameter (ddl_perr_in_sparse             = ddl_base_sparse+ 14)
      parameter (ddl_perr_out_sparse            = ddl_base_sparse+ 15)
      parameter (ddl_perr_coltotriad            = ddl_base_sparse+ 16)
      parameter (ddl_perr_offset_sparse         = ddl_base_sparse+ 17)
      parameter (ddl_perr_comm_sparse           = ddl_base_sparse+ 18)
      parameter (ddl_perr_gsize_sparse          = ddl_base_sparse+ 19)
      parameter (ddl_perr_read_sparse           = ddl_base_sparse+ 20)
      parameter (ddl_perr_used_sparse           = ddl_base_sparse+ 21)
      parameter (ddl_perr_setused_sparse        = ddl_base_sparse+ 22)
      parameter (ddl_perr_setformat_sparse      = ddl_base_sparse+ 23)
      parameter (ddl_perr_write_sparse          = ddl_base_sparse+ 24)
      parameter (ddl_perr_gused_sparse          = ddl_base_sparse+ 25)
      parameter (ddl_perr_get_ia                = ddl_base_sparse+ 26)
      parameter (ddl_perr_get_ja                = ddl_base_sparse+ 27)
      parameter (ddl_perr_get_a                 = ddl_base_sparse+ 28)
      parameter (ddl_perr_smv_comm              = ddl_base_sparse+ 29)
      parameter (ddl_perr_smv                   = ddl_base_sparse+ 30)
      parameter (ddl_perr_copy_sparse           = ddl_base_sparse+ 31)
      parameter (ddl_perr_trisolve              = ddl_base_sparse+ 32)
      parameter (ddl_perr_setsubtype_sparse     = ddl_base_sparse+ 33)
      parameter (ddl_perr_subtype_sparse        = ddl_base_sparse+ 34)
      parameter (ddl_perr_check_perm            = ddl_base_sparse+ 35)
      parameter (ddl_perr_compare_vecvec        = ddl_base_sparse+ 36)
      parameter (ddl_perr_compare_matvec        = ddl_base_sparse+ 37)
      parameter (ddl_perr_block_sparse          = ddl_base_sparse+ 38)
      parameter (ddl_perr_create_prop           = ddl_base_sparse+ 39)
      parameter (ddl_perr_free_prop             = ddl_base_sparse+ 40)
      parameter (ddl_perr_find_prop             = ddl_base_sparse+ 41)
      parameter (ddl_perr_free_allprop          = ddl_base_sparse+ 42)
      parameter (ddl_perr_setperm_sparse        = ddl_base_sparse+ 43)
      parameter (ddl_perr_trisolve_comm         = ddl_base_sparse+ 44)
      parameter (ddl_perr_addperm_vector        = ddl_base_sparse+ 47)
      parameter (ddl_perr_permute_vector        = ddl_base_sparse+ 48)
      parameter (ddl_perr_invperm               = ddl_base_sparse+ 49)

c     function declarations
      logical DDL_Ishost
      double precision DDL_Gettime

c     basic data types like MPI but integers
      integer ddl_float, ddl_double, ddl_int
      parameter (ddl_float = 1)
      parameter (ddl_double = 2)
      parameter (ddl_int = 3)

c     null object types for initialization
      integer ddl_null, ddl_sparse_null, ddl_vector_null
      parameter (ddl_null = 0)
      parameter (ddl_sparse_null = 0)
      parameter (ddl_vector_null = 0)

c     file I/O mode constants
      integer ddl_read_mode, ddl_write_mode
      parameter (ddl_read_mode = 1)
      parameter (ddl_write_mode = 2)

c     maximum number of MPI processes allowed (used for temp buffers)
      integer ddl_maxp
      parameter (ddl_maxp = 100)
